#include <windows.h>
#include <commctrl.h>

#define CM_DIALOG 200
#define CM_PLAY 201
#define CM_STOP 202
#define CM_FOTO2 203
#define CM_FOTO6 204
#define IDC_ANIMATE 301
#define IDC_ANIMATE2 302
#define IDC_MENSAJE 303

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK DlgProc(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */


    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 080",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           230,                 /* Ancho */
           215,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    InitCommonControls();
    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    HWND hctrl;

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           CreateWindowEx(0, "BUTTON", "Play", WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
              10, 10, 45, 20, hwnd, (HMENU)CM_PLAY, hInstance, NULL);
           CreateWindowEx(0, "BUTTON", "Stop", WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
              60, 10, 45, 20, hwnd, (HMENU)CM_STOP, hInstance, NULL);
           CreateWindowEx(0, "BUTTON", "Foto 2", WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
              110, 10, 45, 20, hwnd, (HMENU)CM_FOTO2, hInstance, NULL);
           CreateWindowEx(0, "BUTTON", "Foto 6", WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
              160, 10, 45, 20, hwnd, (HMENU)CM_FOTO6, hInstance, NULL);
           CreateWindowEx(0, "BUTTON", "Dilogo", WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
              110, 40, 65, 20, hwnd, (HMENU)CM_DIALOG, hInstance, NULL);
           CreateWindowEx(0, "STATIC", "", SS_LEFT | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
              110, 70, 95, 20, hwnd, (HMENU)IDC_MENSAJE, hInstance, NULL);
           hctrl = Animate_Create(hwnd, IDC_ANIMATE, WS_BORDER | WS_CHILD | ACS_TRANSPARENT | ACS_AUTOPLAY, hInstance);
           SetWindowPos(hctrl, 0, 10, 40, 48, 45, SWP_NOZORDER | SWP_DRAWFRAME);
           Animate_Open(hctrl, "mundo");
           ShowWindow(hctrl, SW_SHOW);
           EnableWindow(GetDlgItem(hwnd, CM_PLAY), FALSE);
           //Animate_Play(hctrl, 0, -1, -1);
           hctrl = Animate_Create(hwnd, IDC_ANIMATE2, WS_BORDER | WS_CHILD | ACS_TRANSPARENT | ACS_AUTOPLAY, hInstance);
           SetWindowPos(hctrl, 0, 10, 90, 48, 45, SWP_NOZORDER | SWP_DRAWFRAME);
           Animate_Open(hctrl, "Gears.avi");
           ShowWindow(hctrl, SW_SHOW);
           return 0;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
                case CM_DIALOG:
                    DialogBoxParam(hInstance, "Dialogo", hwnd, DlgProc, 0);
                    break;
                case CM_PLAY:
//                    Animate_Play(GetDlgItem(hwnd, IDC_ANIMATE), 0, -1, -1);
                    SendMessage(GetDlgItem(hwnd, IDC_ANIMATE), ACM_PLAY, (WPARAM) (UINT) -1, (LPARAM) MAKELONG(0, -1));
                    break;
                case CM_STOP:
//                    Animate_Stop(GetDlgItem(hwnd, IDC_ANIMATE));
                    SendMessage(GetDlgItem(hwnd, IDC_ANIMATE), ACM_STOP, 0, 0);
                    break;
                case CM_FOTO2:
                    Animate_Seek(GetDlgItem(hwnd, IDC_ANIMATE), 1);
                    break;
                case CM_FOTO6:
                    SendMessage(GetDlgItem(hwnd, IDC_ANIMATE), ACM_PLAY, (WPARAM) (UINT) 0, (LPARAM) MAKELONG(5, 5));
                    break;
                case IDC_ANIMATE:
                    switch(HIWORD(wParam)) {
                        case ACN_START:
                            SetWindowText(GetDlgItem(hwnd, IDC_MENSAJE), "Marcha");
                            EnableWindow(GetDlgItem(hwnd, CM_PLAY), FALSE);
                            EnableWindow(GetDlgItem(hwnd, CM_STOP), TRUE);
                            break;
                        case ACN_STOP:
                            SetWindowText(GetDlgItem(hwnd, IDC_MENSAJE), "Parado");
                            EnableWindow(GetDlgItem(hwnd, CM_PLAY), TRUE);
                            EnableWindow(GetDlgItem(hwnd, CM_STOP), FALSE);
                            break;
                    }
                    break;
           }
           break;
        case WM_DESTROY:
           Animate_Close(GetDlgItem(hwnd, IDC_ANIMATE));
           Animate_Close(GetDlgItem(hwnd, IDC_ANIMATE2));
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

BOOL CALLBACK DlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_INITDIALOG:
           return TRUE;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
                case IDOK:
                case IDCANCEL:
                    EndDialog(hDlg, FALSE);
                    break;
           }
           return TRUE;
    }
    return FALSE;
}
